
/**
 * Beschreiben Sie hier die Klasse Dijkstra2.
 * 
 * @author (Ihr Name) 
 * @version (eine Versionsnummer oder ein Datum)
 */
import graph.*;

import javax.swing.JTextPane;
public class Dijkstra2 //extends Thread
{ 
   private Graph bspGraph;
   private String start;
   private String ziel;
   private List<String> taProtokoll;
   private PrioritaetsSchlange schlange;
   private JTextPane textFeld;
   
   public Dijkstra2 (Graph pGraph, String pStart, String pZiel, JTextPane pTextfeld){
       bspGraph = pGraph;
       start = pStart;
       ziel = pZiel;
       textFeld = pTextfeld;
       taProtokoll = new List<String>();
       zuruecksetzenDijkstraVertices(bspGraph);
    }
   
   public void zuruecksetzenDijkstraVertices(Graph pGraph) {
		List<Vertex> knoten = pGraph.getVertices();
		while (knoten.hasAccess()) {
			DijkstraVertex djk = (DijkstraVertex) knoten.getContent();
			djk.setzeDistanz(-1);
			((DijkstraVertex) knoten.getContent()).setzeVorgaenger(null);
			((DijkstraVertex) knoten.getContent()).setMark(false);
			knoten.next();
		}
	}
    
    private void dijkstra(DijkstraVertex pStart, DijkstraVertex pZiel) 
    {  if (pStart!= null && pZiel != null) 
     {  schlange = new PrioritaetsSchlange();
         pStart.setzeDistanz(0);
         schlange.fuegeEin(pStart);
         protokolliere();
         DijkstraVertex nachbarKnoten = null;
         DijkstraVertex ersterKnoten = null;
         while (!schlange.isEmpty() && ersterKnoten != pZiel) 
         {  schlange.toFirst();
            ersterKnoten = (DijkstraVertex)schlange.getObject();
            schlange.remove();
            if (!ersterKnoten.isMarked()) 
            {   ersterKnoten.setMark(true);
                List<Vertex> nachbarListe = bspGraph.getNeighbours(ersterKnoten);
                nachbarListe.toFirst();
                while (nachbarListe.hasAccess()) 
                {  nachbarKnoten = (DijkstraVertex) nachbarListe.getContent();
                    Edge kante = bspGraph.getEdge(nachbarKnoten, ersterKnoten);
                    double gewicht = kante.getWeight();
                   if ( nachbarKnoten.gibDistanz() == -1 || nachbarKnoten.gibDistanz() > ersterKnoten.gibDistanz()+gewicht) 
                   {   nachbarKnoten.setzeDistanz(ersterKnoten.gibDistanz()+gewicht);
                       nachbarKnoten.setzeVorgaenger(ersterKnoten);
                       schlange.fuegeEin(nachbarKnoten);
                   }
                   nachbarListe.next();
                }
            }
            protokolliere();
         }
     }
  }

    public void protokolliere()
  { 
      String str = "";
      double hilf; 
      DijkstraVertex knoten, vorgaenger;
      List<Vertex> knotenListe = bspGraph.getVertices();
      knotenListe.toFirst();
      str = "\nKnotenliste (Name, Distanz, Vorgänger)\n";
      while (knotenListe.hasAccess())
      {  knoten = (DijkstraVertex) knotenListe.getContent();
         hilf = (int) knoten.gibDistanz();
         if (hilf == -1) {
             str = str + knoten.getID() + "( --- )";
            }
         else {
             str = str + knoten.getID() + "(" + hilf + ")";
         }
         vorgaenger = knoten.gibVorgaenger();
         if (vorgaenger == null) str = str +  "-   ";
         else str = str + vorgaenger.getID() + "  ";
         knotenListe.next();
      }
      str = str + "\nSchlange: ";
      str = str + schlange.toString() + "\n";
      taProtokoll.append(str); 
  }
    
    public void ausgabe(DijkstraVertex startKnoten, DijkstraVertex zielKnoten){
      	textFeld.setText("Kürzester Weg Dijkstra-Algorithmus\n");
    	DijkstraVertex alt = zielKnoten;
    	 while (alt!=startKnoten){
       		 DijkstraVertex vorgaenger = alt.gibVorgaenger();
       		 Edge kante = bspGraph.getEdge(vorgaenger, alt);
       		 kante.setMark(true);
       		 alt = vorgaenger;
       	 }
       	 bspGraph.setAllVertexMarks(false);
       	 taProtokoll.toFirst();
       	 while (taProtokoll.hasAccess()){
       		 String zeile = taProtokoll.getContent();
       		 textFeld.setText(textFeld.getText()+zeile);
       		 taProtokoll.next();
       	 }
       	 textFeld.setText(textFeld.getText()+"Weglaenge von "+start + " nach "+ziel+": "+zielKnoten.gibDistanz());

    }

  
    public void run() {
   	 DijkstraVertex sk =(DijkstraVertex) bspGraph.getVertex(start);
   	 DijkstraVertex zk = (DijkstraVertex)bspGraph.getVertex(ziel);
   	 this.dijkstra(sk,zk);

   	 ausgabe(sk, zk);
   	
    }

}
