import java.awt.Color;
import java.awt.EventQueue;
import java.awt.FlowLayout;

import javax.swing.BoxLayout;

import java.awt.event.*;

import javax.swing.JFrame;
import javax.swing.JPanel;

import java.awt.BorderLayout;

import javax.swing.JButton;
import javax.swing.SwingConstants;
import javax.swing.JToggleButton;
import javax.swing.JRadioButton;

import java.awt.event.ActionEvent;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.io.File;

import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.ButtonGroup;
import javax.swing.JTextPane;
import javax.swing.JScrollPane;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

import graph.Graph;
import graph.Vertex;
import graph.Edge;
import graph.List;

@SuppressWarnings("serial")
public class GraphTool extends JFrame {

	private JPanel contentPane;
	private Graph myGraph;
	private GraphCanvas canvas;
	private JToggleButton tglbtnKnoten;
	private JToggleButton tglbtnBearbeiten;
	private JButton btnRun;
	private JButton btnKante;
	private JButton btnNeu;
	private JButton btnLoeschen;
	private JComboBox<String> jcmbstart;
	private JComboBox<String> jcmbziel;
	private JRadioButton btnTiefe;
	private JRadioButton btnBreite;
	private JRadioButton btnBacktracking;
	private JRadioButton btnDijkstra;
	private JRadioButton rdbtnPrim;
	private JRadioButton rdbtnKruskal;
	private JButton btnLaden;
	private JButton btnSpeichern;
	private JTextPane textFeld;
	private JFileChooser fileChooser;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GraphTool frame = new GraphTool();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public GraphTool() {
		myGraph = new Graph();
		setResizable(false);
		setAlwaysOnTop(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(1024, 550);

		contentPane = new JPanel();
		contentPane.setLayout(new BorderLayout());
		setContentPane(contentPane);
		ActionListener al = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doAction(e);
			}
		};
		ActionListener alRun = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doRunAction(e);
			}
		};
		ActionListener alIO = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ioAction(e);
			}
		};
		JPanel pnlMenue = new JPanel();
		pnlMenue.setLayout(new FlowLayout(FlowLayout.LEFT));
		pnlMenue.setMinimumSize(new Dimension(790, 46));
		contentPane.add(pnlMenue, BorderLayout.NORTH);

		btnSpeichern = new JButton("");
		btnSpeichern.setIcon(new ImageIcon("ico/save.png"));
		btnSpeichern.setPreferredSize(new Dimension(42, 42));
		pnlMenue.add(btnSpeichern);
		btnSpeichern.addActionListener(alIO);

		btnLaden = new JButton("");
		btnLaden.setIcon(new ImageIcon("ico/load.png"));
		btnLaden.setPreferredSize(new Dimension(42, 42));
		btnLaden.addActionListener(alIO);
		pnlMenue.add(btnLaden);

		btnNeu = new JButton("");
		btnNeu.setIcon(new ImageIcon("ico/neu.png"));
		btnNeu.setPreferredSize(new Dimension(42, 42));
		btnNeu.addActionListener(al);
		pnlMenue.add(btnNeu);

		btnLoeschen = new JButton(new ImageIcon("ico/loeschen.png"));
		btnLoeschen.setPreferredSize(new Dimension(42, 42));
		btnLoeschen.addActionListener(al);
		pnlMenue.add(btnLoeschen);

		btnKante = new JButton("");
		btnKante.setIcon(new ImageIcon("ico/kante.png"));
		btnKante.setPreferredSize(new Dimension(42, 42));
		btnKante.setHorizontalAlignment(SwingConstants.LEFT);
		btnKante.addActionListener(al);
		pnlMenue.add(btnKante);

		tglbtnKnoten = new JToggleButton("");
		tglbtnKnoten.setPreferredSize(new Dimension(42, 42));
		pnlMenue.add(tglbtnKnoten);
		tglbtnKnoten.setIcon(new ImageIcon("ico/knoten.png"));
		tglbtnKnoten.addActionListener(al);

		tglbtnBearbeiten = new JToggleButton("");
		tglbtnBearbeiten.setIcon(new ImageIcon("ico/edit.png"));
		tglbtnBearbeiten.setPreferredSize(new Dimension(42, 42));
		tglbtnBearbeiten.addActionListener(al);
		pnlMenue.add(tglbtnBearbeiten);

		contentPane.add(pnlMenue, BorderLayout.NORTH);

		JPanel pnlAlgo = new JPanel();
		BoxLayout bolo = new BoxLayout(pnlAlgo, BoxLayout.PAGE_AXIS);

		pnlAlgo.setLayout(bolo);
		contentPane.add(pnlAlgo, BorderLayout.WEST);

		JPanel startVertex = new JPanel();
		startVertex.setPreferredSize(new Dimension(170, 50));
		Border titledLine = BorderFactory.createTitledBorder("Knoten");
		startVertex.setBorder(titledLine);
		startVertex.setLayout(new GridLayout(2, 2));
		startVertex.add(new JLabel("Startknoten"));

		jcmbstart = new JComboBox<String>();
		startVertex.add(jcmbstart, 0, 1);
		startVertex.add(new JLabel("Zielknoten"));
		pnlAlgo.add(startVertex);
		jcmbziel = new JComboBox<String>();
		startVertex.add(jcmbziel);
		contentPane.add(pnlAlgo, BorderLayout.WEST);

		JPanel panelTrav = new JPanel();
		panelTrav.setPreferredSize(new Dimension(120, 30));
		panelTrav.setBorder(BorderFactory.createTitledBorder("Traversierung"));
		panelTrav.setLayout(new GridLayout(2, 1));
		ButtonGroup group = new ButtonGroup();
		btnTiefe = new JRadioButton("Tiefendurchlauf");
		btnBreite = new JRadioButton("Breitendurchlauf");
		btnTiefe.setSelected(true);
		group.add(btnTiefe);
		group.add(btnBreite);
		panelTrav.add(btnTiefe);
		panelTrav.add(btnBreite);
		pnlAlgo.add(panelTrav);

		JPanel panelWeg = new JPanel();
		panelWeg.setPreferredSize(new Dimension(120, 30));
		panelWeg.setBorder(BorderFactory.createTitledBorder("Wegsuche"));
		panelWeg.setLayout(new GridLayout(2, 1));
		btnBacktracking = new JRadioButton("Backtracking");
		btnDijkstra = new JRadioButton("Dijkstra");
		group.add(btnBacktracking);
		group.add(btnDijkstra);
		panelWeg.add(btnBacktracking);
		panelWeg.add(btnDijkstra);
		pnlAlgo.add(panelWeg);

		JPanel panelSpannbaum = new JPanel();
		panelSpannbaum.setPreferredSize(new Dimension(120, 30));
		panelSpannbaum.setBorder(BorderFactory.createTitledBorder("Spannbaum"));
		panelSpannbaum.setLayout(new GridLayout(2, 1));
		rdbtnPrim = new JRadioButton("Prim");
		rdbtnKruskal = new JRadioButton("Kruskal");
		panelSpannbaum.add(rdbtnPrim, 0, 0);
		panelSpannbaum.add(rdbtnKruskal, 1, 0);
		group.add(rdbtnPrim);
		;
		group.add(rdbtnKruskal);
		pnlAlgo.add(panelSpannbaum);

		JPanel panelRun = new JPanel();
		panelRun.setPreferredSize(new Dimension(120, 100));
		btnRun = new JButton("Start");
		btnRun.setPreferredSize(new Dimension(170, 50));
		btnRun.setAlignmentX(1);
		btnRun.addActionListener(alRun);
		panelRun.add(btnRun);
		
		pnlAlgo.add(panelRun);

		canvas = new GraphCanvas(myGraph);
		canvas.setBackground(Color.white);
		Border blackline = BorderFactory.createLineBorder(Color.black);
		canvas.setBorder(blackline);
		contentPane.add(canvas, BorderLayout.CENTER);
		JPanel textPanel = new JPanel(new BorderLayout());
		textPanel.setPreferredSize(new Dimension(324, 550));
		textFeld = new JTextPane();
		JScrollPane scrollPane = new JScrollPane(textFeld);
		scrollPane.setSize(300, 500);
		textPanel.setBorder(BorderFactory.createTitledBorder("Protokoll"));
		textFeld.setBackground(Color.white);
		textPanel.add(scrollPane, BorderLayout.CENTER);
		contentPane.add(textPanel, BorderLayout.EAST);
		fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		FileNameExtensionFilter filter = new FileNameExtensionFilter(
			        "Graphen", "grf");
	    fileChooser.setFileFilter(filter);
	}

	public JTextPane getTextFeld(){
		return textFeld;
	}
	
	public void setComboBoxes() {
		List<Vertex> vList = myGraph.getVertices();
		vList.toFirst();
		jcmbstart.removeAllItems();
		jcmbziel.removeAllItems();
		while (vList.hasAccess()) {
			jcmbstart.addItem(vList.getContent().getID());
			jcmbziel.addItem(vList.getContent().getID());
			vList.next();
		}
	}

	public void doAction(ActionEvent e) {
		Object src = e.getSource();
		if (src == tglbtnKnoten) {
			canvas.toggleInsertVertex();
			if (!tglbtnKnoten.isSelected()) {
				setComboBoxes();
			}
			tglbtnBearbeiten.setSelected(false);
		}
		if (src == tglbtnBearbeiten) {
			canvas.toggleEditGraph();
			tglbtnKnoten.setSelected(false);
			setComboBoxes();
		}
		if (src == btnLoeschen) {
			canvas.loesche();
			setComboBoxes();
		}
		if (src == btnKante) {
			canvas.neueKanten();
		}
		if (src == btnNeu) {
			myGraph = new Graph();
			canvas.setGraph(myGraph);
			canvas.resetVName();
			canvas.repaint();
		}

	}

	public void doRunAction(ActionEvent e) {
		myGraph.setAllEdgeMarks(false);
		myGraph.setAllVertexMarks(false);
		canvas.repaint();
		Object obj = e.getSource();
		if (obj == btnRun) {

			if (rdbtnPrim.isSelected()) {
				Prim primAlgo = new Prim(myGraph, getTextFeld());
				primAlgo.run();
				repaint();
			} else {
				if (btnTiefe.isSelected()) {
					String start = (String) jcmbstart.getSelectedItem();
					Tiefensuche tiefens = new Tiefensuche(myGraph, start, getTextFeld());
					tiefens.run();
					repaint();
				} else {
					if (btnBreite.isSelected()) {
						String start = (String) jcmbstart.getSelectedItem();
						Breitendurchlauf breitens = new Breitendurchlauf(myGraph, start, getTextFeld());
						breitens.run();
						repaint();
					} else {
						if (rdbtnKruskal.isSelected()) {
							MSBKruskal kruskalAlgo = new MSBKruskal(myGraph, getTextFeld());
							kruskalAlgo.run();
                            repaint();
						} else {
							if (btnBacktracking.isSelected()) {
								String start = (String) jcmbstart
										.getSelectedItem();
								String ziel = (String) jcmbziel
										.getSelectedItem();
								WeglaengeBacktracking wegBack = new WeglaengeBacktracking(myGraph,start, ziel, getTextFeld());
								wegBack.run();
								repaint();

							} else {
								if (btnDijkstra.isSelected()) {
									String start = (String) jcmbstart
											.getSelectedItem();
									String ziel = (String) jcmbziel
											.getSelectedItem();
									Dijkstra2 wegDij = new Dijkstra2(myGraph, start, ziel, getTextFeld());
									wegDij.run();
									repaint();

								}
							}
						}
					}
				}

			}

		}
	}

	public void ioAction(ActionEvent e) {

		Object obj = e.getSource();
		String name = "Graph1";

		GraphIO gio = new GraphIO();
		File selectedFile = new File("");
		if (obj == btnSpeichern) {
			int result = fileChooser.showSaveDialog(this);
			if (result == JFileChooser.APPROVE_OPTION) {
			    selectedFile = fileChooser.getSelectedFile();
			    name = selectedFile.getAbsolutePath();  
			    gio.save(myGraph,name);
			}
		} else {
			if (obj == btnLaden) {
				int result = fileChooser.showOpenDialog(this);
				if (result == JFileChooser.APPROVE_OPTION) {
				   selectedFile = fileChooser.getSelectedFile();
				   myGraph = gio.load(selectedFile.getAbsolutePath());
				   canvas.setGraph(myGraph);
				   setComboBoxes();
				   repaint();
				}
			}
		}
	}

	
}
