
import graph.*;
import javax.swing.JTextPane;

public class Tiefensuche  {
	private Graph bspGraph;
	private Vertex startKnoten;
	private JTextPane text;

	public Tiefensuche(Graph pGraph, String pStart, JTextPane pText) {
		bspGraph = pGraph;
		startKnoten = bspGraph.getVertex(pStart);
		text = pText;
	}

	public String tiefendurchlaufToString(List<Vertex> liste) {
		String ausgabe = "Tiefendurchlauf\n";
		ausgabe = ausgabe+"Reihenfolge der besuchten Knoten:\n";
		liste.toFirst();
		while (liste.hasAccess()) {
			Vertex knoten = (Vertex) liste.getContent();
			ausgabe = ausgabe + knoten.getID() + " ";
			liste.next();
		}
		return ausgabe + "\n";
	}

	public synchronized List<Vertex> tiefendurchlauf(Vertex pStartKnoten) {
		List<Vertex> ergebnisListe = new List<Vertex>();
		if (!pStartKnoten.isMarked()) {
			pStartKnoten.setMark(true);
			ergebnisListe.append(pStartKnoten);
			List<Vertex> nachbarliste = bspGraph.getNeighbours(pStartKnoten);
			nachbarliste.toFirst();
			while (nachbarliste.hasAccess()) {
				Vertex nV = (Vertex) nachbarliste.getContent();
				ergebnisListe.concat(tiefendurchlauf(nV));
				nachbarliste.next();
			}
		}
		return ergebnisListe;
	}

	public void run() {
		text.setText("");
		bspGraph.setAllVertexMarks(false);
		List<Vertex> laufListe = tiefendurchlauf(startKnoten);
		bspGraph.setAllVertexMarks(false);
		text.setText(tiefendurchlaufToString(laufListe));

	}
}
