import java.awt.*;
import java.awt.event.*;

import graph.*;
import dijkstra.*;
import backtracking.*;
public class KuezesterWeg_GUI extends Frame {
  // Anfang Attribute
  private TextArea textArea1 = new TextArea("", 1, 1, TextArea.SCROLLBARS_VERTICAL_ONLY);
  private Button btnDijkstra = new Button();
  private Button btnKurzWeg = new Button();
  private Label label1 = new Label();
  private Label label2 = new Label();
  private TextField textField1 = new TextField();
  private TextField textField2 = new TextField();
  private Button btnGraph = new Button();
  // Ende Attribute
  private Graph bspGraph;

  public KuezesterWeg_GUI(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { dispose(); }
    });
    int frameWidth = 538; 
    int frameHeight = 340;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Panel cp = new Panel(null);
    add(cp);
    // Anfang Komponenten

    textArea1.setBounds(16, 16, 355, 280);
    textArea1.setText("(Strings)");
    textArea1.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(textArea1);
    
    label1.setBounds(392, 16, 38, 20);
    label1.setText("Start");
    cp.add(label1);
    
    label2.setBounds(392, 48, 38, 20);
    label2.setText("Ziel");
    cp.add(label2);
    
    textField1.setBounds(450, 16, 62, 20);
    textField1.setText("K");
    cp.add(textField1);
    
    textField2.setBounds(450, 48, 62, 20);
    textField2.setText("H");
    cp.add(textField2);
    
    btnGraph.setBounds(378, 80, 139, 25);
    btnGraph.setLabel("Adjazenzlisten");
    btnGraph.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btnGraph_ActionPerformed(evt);
      }
    });
    cp.add(btnGraph);
    
    
    btnDijkstra.setBounds(378, 200, 139, 25);
    btnDijkstra.setLabel("Dijkstra");
    btnDijkstra.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnDijkstra_ActionPerformed(evt);
      }
    });
    btnDijkstra.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(btnDijkstra);
    
    btnKurzWeg.setBounds(378, 240, 139, 25);
    btnKurzWeg.setLabel("\nKrzester Weg");
    btnKurzWeg.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnKurzWeg_ActionPerformed(evt);
      }
    });
    btnKurzWeg.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(btnKurzWeg);  
   
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
    textArea1.setText("");
    bspGraph = new Graph();
    erzeugeBeispiel();
  }
  
  
  public void erzeugeBeispiel() {
    bspGraph.addVertex(new DijkstraVertex("A"));
    bspGraph.addVertex(new DijkstraVertex("B"));
    bspGraph.addVertex(new DijkstraVertex("C"));
    bspGraph.addVertex(new DijkstraVertex("E"));
    bspGraph.addVertex(new DijkstraVertex("F"));
    bspGraph.addVertex(new DijkstraVertex("G"));
    bspGraph.addVertex(new DijkstraVertex("H"));
    bspGraph.addVertex(new DijkstraVertex("I"));
    bspGraph.addVertex(new DijkstraVertex("K"));
    bspGraph.addVertex(new DijkstraVertex("L"));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("B"),20));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("G"),125));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("C"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("F"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("C"),bspGraph.getVertex("E"),40));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("F"),50));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("K"),70));    
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("L"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("G"),100));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("K"),45));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("K"),60));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("H"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("I"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("H"),bspGraph.getVertex("I"),45));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("I"),bspGraph.getVertex("K"),10));
  }
  
  public String adListenToString(Graph graph) {
    String ausgabe = "Adjazenzlisten \n";
    graph.List<Vertex> knotenliste = bspGraph.getVertices();
    knotenliste.toFirst();
    while (knotenliste.hasAccess()) {
      Vertex knoten = knotenliste.getContent();
      ausgabe = ausgabe + knoten.getID()+":\t";
      graph.List<Vertex> nachbarliste = bspGraph.getNeighbours(knoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        Vertex k = nachbarliste.getContent();
        ausgabe = ausgabe + k.getID() + " "+ bspGraph.getEdge(knoten,k).getWeight()+" ";
        nachbarliste.next();
      }
      ausgabe = ausgabe + "\n";
      knotenliste.next();
    }
    return ausgabe;
  }

   public void btnGraph_ActionPerformed(ActionEvent evt) {
    textArea1.append(adListenToString(bspGraph)+"\n");
  } // end of button5_ActionPerformed
  
  
  public String listeToString(graph.List<Vertex> wegListe){
      String wegString = "";
      wegListe.toFirst();
      while (wegListe.hasAccess()){
          wegString = wegString+wegListe.getContent().getID();
          wegListe.next();
        }
      return wegString;
    }
  
  public void btnDijkstra_ActionPerformed(ActionEvent evt) {
    String s = textField1.getText();
    String z = textField2.getText();
    Dijkstra dij = new Dijkstra(bspGraph);
    dij.findeKuerzestenWegDijkstra(s,z);
    textArea1.append("Dijkstra: "+ listeToString(dij.gibRoute())+"\n");
    textArea1.append("Weglnge:"+dij.gibWeglaenge()+"\n");
  }
  
  public void btnKurzWeg_ActionPerformed(ActionEvent evt) {
    String s = textField1.getText();
    String z = textField2.getText();
    Backtracking bt = new Backtracking(bspGraph);
    bt.findeKuerzestenWegBacktracking(s,z);
    textArea1.append("Backtracking: "+listeToString(bt.getRoute())+"\n");
    textArea1.append("Weglnge:"+bt.getWeglaenge()+"\n");
  }


  
 

  // Ende Methoden

  public static void main(String[] args) {
    new KuezesterWeg_GUI("Graph_GUI");
  }
}
