package backtracking;

 
import graph.*;
public class Backtracking {
  private Graph bspGraph; 
  private List<Vertex> route;
  private double wegLaenge;
 

  public Backtracking(Graph pGraph) {
    bspGraph = pGraph;  
    route = new List<Vertex>();
    wegLaenge = 0;
  }
  
  public double getWeglaenge(){
      return wegLaenge;
  }
  
  public List <Vertex>getRoute(){
      return route;
  }
  
  
   public void findeKuerzestenWegBacktracking(String start, String ziel){
     List<Vertex> weg = new List<Vertex>();
     Vertex startKnoten = bspGraph.getVertex(start);
     Vertex zielKnoten = bspGraph.getVertex(ziel);
     List<Vertex> kurzWeg = new List<Vertex>();
     double minweg = gewichtsSumme();
     double wegL = 0;
     bspGraph.setAllVertexMarks(false);
     wegLaenge = findeKuerzestenWeg(startKnoten, zielKnoten, weg, kurzWeg, wegL, minweg);   
     route = kurzWeg;
   }
  
   private double findeKuerzestenWeg(Vertex knoten, Vertex ziel, List<Vertex> weg, List<Vertex> kurzWeg, double wegL, double minWegLaenge){
       knoten.setMark(true);
       weg.append(knoten);
      if (knoten != ziel){
          List<Vertex> nachbarn = bspGraph.getNeighbours(knoten);
          nachbarn.toFirst();
          while (nachbarn.hasAccess()) {
              Vertex nachbar = nachbarn.getContent();
              if (!nachbar.isMarked()){
                  double distanz = bspGraph.getEdge(knoten, nachbar).getWeight();
                  wegL = wegL + distanz; 
                  minWegLaenge  = findeKuerzestenWeg(nachbar, ziel, weg, kurzWeg, wegL, minWegLaenge);
                    //Schritt rueckgaengig machen
                  weg.toLast();
                  Vertex loeschKnoten = weg.getContent();
                  loeschKnoten.setMark(false);
                  wegL = wegL - distanz;
                   weg.remove(); 
                  
              }
              nachbarn.next();
          }    
        } else {
            if (wegL < minWegLaenge){
                minWegLaenge = wegL;
                copy(weg, kurzWeg);
            }
          }
       return minWegLaenge;
         
    }
    
  public double gewichtsSumme() {
    bspGraph.setAllVertexMarks(false);
    return gewichte(bspGraph.getVertex("A"))/2;
  }

  private double gewichte(Vertex pKnoten) {
    double entfernung =0.0;
    if (!pKnoten.isMarked()) {
      pKnoten.setMark(true);
      List<Vertex>nachbarliste = bspGraph.getNeighbours(pKnoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        Vertex g = nachbarliste.getContent();
        entfernung = entfernung + bspGraph.getEdge(pKnoten,g).getWeight();
        entfernung = entfernung + gewichte(g);
        nachbarliste.next();
      }
    }
    return entfernung;
  }
  
  
 private void copy(List<Vertex>liste1, List<Vertex> liste2){
      liste2.toFirst();
      while (!liste2.isEmpty()){
          liste2.remove();
        }
      liste1.toFirst();
      while (liste1.hasAccess()){
          liste2.append(liste1.getContent());
          liste1.next();
      }
      
    }
     
}

