package dijkstraObjekt;

import graph.*;
public class DijkstraO {
		
		private Graph meinGraph; //Muss aus Instanzen von meiner Klasse DijkstraVertex bestehen
	    private List<Vertex> route;
	    private double wegLaenge = 0;
		
		
		public DijkstraO(Graph pGraph) {
		    meinGraph = pGraph;
		}
		
		public void konstruiereRoute(Vertex knoten){
			wegLaenge = 0;
			route = new List<Vertex>();
			do {
				route.toFirst();
				route.insert(knoten);
				Vertex vorgaenger = knoten.gibVorgaenger();
				if (vorgaenger!=null) {
				   Edge kante = meinGraph.getEdge(knoten, vorgaenger);
				   wegLaenge = wegLaenge + kante.getWeight();
				   route.next();
				}
				knoten = vorgaenger;
			}
			while (knoten != null);
		}
		
		
	   public void zuruecksetzen() {
		 List<Vertex> knoten = meinGraph.getVertices();
		 while (knoten.hasAccess()) {
			DijkstraVertex djk = (DijkstraVertex) knoten.getContent();
			djk.setzeEntfernung(-1);
			((DijkstraVertex) knoten.getContent()).setzeVorgaenger(null);
			((DijkstraVertex) knoten.getContent()).setMark(false);
			knoten.next();
		 }
	}

	 public void findeKuerzestenWegDijkstraObjekt(String start, String ziel){
	     zuruecksetzen();
	     DijkstraVertex startKnoten = (DijkstraVertex)bspGraph.getVertex(start);
         DijkstraVertex zielKnoten = (DijkstraVertex)bspGraph.getVertex(ziel);
         findeKuerzestenWeg(startKnoten, zielKnoten);
    }
	
		public void findeKuerzesteWeg(DijkstraVertex pStartKnoten, DijkstraVertex pZielKnoten)
		{
			//Drei Knotenmengen fuer Dijkstra instanziieren:
			FertigeKnotenmenge fertigeKnoten = new FertigeKnotenmenge();
			AktiveKnotenmenge aktiveKnoten = new AktiveKnotenmenge(fertigeKnoten);
			UnentdeckteKnotenmenge untentdeckteKnoten = new UnentdeckteKnotenmenge(meinGraph.getVertices(),aktiveKnoten);
			
			//Startknoten aktivieren, d.h. in die Menge der aktiven Knoten verschieben...
			untentdeckteKnoten.aktiviereKnoten(pStartKnoten, 0, null);
			DijkstraVertex aktuellerKnoten = pStartKnoten;
			
			//...und dann solange weitermachen, wie es noch aktive Knoten gibt:
			while(!aktiveKnoten.istLeer() && aktuellerKnoten!=pZielKnoten)
			{ 
				aktuellerKnoten = aktiveKnoten.gibKnotenMitMinimalerDistanz();
				
				List<Vertex> nachbarn = meinGraph.getNeighbours(aktuellerKnoten);		
				//Aktuellen Knoten expandieren:
				for(nachbarn.toFirst();nachbarn.hasAccess();nachbarn.next())
				{
					DijkstraVertex einNachbar = (DijkstraVertex)nachbarn.getContent();
					double entfernungAufDiesemWeg = aktuellerKnoten.gibEntfernung() + meinGraph.getEdge(aktuellerKnoten,einNachbar).getWeight();
					
					if(untentdeckteKnoten.enthaelt(einNachbar))
						untentdeckteKnoten.aktiviereKnoten(einNachbar, entfernungAufDiesemWeg, aktuellerKnoten);
					else //Auswertung nach bellman'schem Optimalitaetsprinzip:
						aktiveKnoten.updateWennNeueEntfernungGeringer(einNachbar,entfernungAufDiesemWeg,aktuellerKnoten);
				}
				
				//Aktuellen Knoten in die Menge der fertigen Knoten verschieben:
				aktiveKnoten.finalisiereKnoten(aktuellerKnoten);
			}
		   konstruiereRoute(pZielKnoten);
		}
		
	public List<DijkstraVertex> gibRoute(){
		return route;
	}
	
	public double gibWeglaenge(){
		return wegLaenge;
	}
	
		
	}