 
import graph.*;
public class WegSuche {
  private Graph bspGraph; 
 

  public WegSuche() {
    bspGraph = new Graph();  
    erzeugeBeispiel();
  }
  
  public void erzeugeBeispiel() {
    bspGraph.addVertex(new Vertex("A"));
    bspGraph.addVertex(new Vertex("B"));
    bspGraph.addVertex(new Vertex("C"));
    bspGraph.addVertex(new Vertex("E"));
    bspGraph.addVertex(new Vertex("F"));
    bspGraph.addVertex(new Vertex("G"));
    bspGraph.addVertex(new Vertex("H"));
    bspGraph.addVertex(new Vertex("I"));
    bspGraph.addVertex(new Vertex("K"));
    bspGraph.addVertex(new Vertex("L"));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("B"),20));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("G"),125));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("C"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("F"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("C"),bspGraph.getVertex("E"),40));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("F"),50));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("K"),70));  
    bspGraph.addEdge(new Edge(bspGraph.getVertex("E"),bspGraph.getVertex("L"),30));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("G"),100));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("F"),bspGraph.getVertex("K"),45));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("K"),60));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("H"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("G"),bspGraph.getVertex("I"),15));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("H"),bspGraph.getVertex("I"),45));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("I"),bspGraph.getVertex("K"),10));
 
  }
  
  public String adListenToString() {
    String ausgabe = "Adjazenzlisten \n";
    List<Vertex> knotenliste = bspGraph.getVertices();
    knotenliste.toFirst();
    while (knotenliste.hasAccess()) {
      Vertex knoten = knotenliste.getContent();
      ausgabe = ausgabe + knoten.getID()+":\t";
      List<Vertex> nachbarliste = bspGraph.getNeighbours(knoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        Vertex k = nachbarliste.getContent();
        ausgabe = ausgabe + k.getID() + " "+ bspGraph.getEdge(knoten,k).getWeight()+" ";
        nachbarliste.next();
      }
      ausgabe = ausgabe + "\n";
      knotenliste.next();
    }
    return ausgabe;
  }
  
   public String knotenListeToString(List<Vertex> liste){
      liste.toFirst();
      String listenString ="";
      while (liste.hasAccess()) {
          String id = liste.getContent().getID();
          listenString = listenString + id + " ";
          liste.next();
      }
      return listenString;
  }
  
  public void copy(List<Vertex>liste1, List<Vertex> liste2){
      liste2.toFirst();
      while (!liste2.isEmpty()){
          liste2.remove();
        }
      liste1.toFirst();
      while (liste1.hasAccess()){
          liste2.append(liste1.getContent());
          liste1.next();
      }
      
    }
    
  
  public String sucheWegToString(String start, String ziel){
     List<Vertex> weg = new List<Vertex>();
     bspGraph.setAllVertexMarks(false);
     Vertex startKnoten = bspGraph.getVertex(start);
     Vertex zielKnoten = bspGraph.getVertex(ziel);
     String wegString;
     if (sucheWeg(startKnoten, zielKnoten, weg)) {   
        wegString =  knotenListeToString(weg);
     } else {
         wegString = "";
      }
      return wegString;
  }

  
  public boolean  sucheWeg(Vertex knoten, Vertex ziel, List<Vertex> weg){
      boolean wegGefunden = false; 
      knoten.setMark(true);
      weg.append(knoten);
      if (knoten != ziel){ 
          List<Vertex> nachbarn = bspGraph.getNeighbours(knoten);
          nachbarn.toFirst();
          while (!wegGefunden && nachbarn.hasAccess()) {
              Vertex nachbar = nachbarn.getContent();
              if (!nachbar.isMarked()){
                  wegGefunden = sucheWeg(nachbar, ziel, weg);
                   if (!wegGefunden) {
                           weg.toLast();
                           Vertex loeschKnoten = weg.getContent();
                           loeschKnoten.setMark(false);
                           weg.remove();
                        } 
               }
              nachbarn.next();
          } 
      } else {
          wegGefunden = true;
        }
      return wegGefunden;
  }
  
   public String sucheWegBreiteToString(String start, String ziel){
     List<Vertex> besuchteKnoten = new List<Vertex>();
     bspGraph.setAllVertexMarks(false);
     Vertex startKnoten = bspGraph.getVertex(start);
     Vertex zielKnoten = bspGraph.getVertex(ziel);
     String wegString;
     if (breitenSuche(startKnoten, zielKnoten, besuchteKnoten)) {   
        List<Vertex> weg = konstruiereWeg(besuchteKnoten); 
        wegString =  knotenListeToString(weg);
     } else {
         wegString = "";
      }
      return wegString;
  }
  
  
  public boolean breitenSuche(Vertex knoten, Vertex ziel, List<Vertex> besucht){
        Queue<Vertex> schlange = new Queue<Vertex>();
        schlange.enqueue(knoten);
        knoten.setMark(true);
        boolean gefunden = false;
        while (!schlange.isEmpty() && !gefunden){
            knoten = schlange.front();
            besucht.append(knoten);
            schlange.dequeue();
            if (knoten != ziel) {
               List<Vertex> nachbarn = bspGraph.getNeighbours(knoten);
               nachbarn.toFirst();
               while (nachbarn.hasAccess()){
                 Vertex nachbar = nachbarn.getContent();
                 if (!nachbar.isMarked()) {
                    schlange.enqueue(nachbar);
                    nachbar.setMark(true);
                 }
                 nachbarn.next();
               } 
            } else {
                gefunden = true;
            }
        }
        return gefunden;
    }
             
    public List<Vertex> konstruiereWeg(List<Vertex> knotenListe){
        Stack<Vertex> stack = new Stack<Vertex>();
        knotenListe.toFirst();
        while (knotenListe.hasAccess()){
            stack.push(knotenListe.getContent());
            knotenListe.next();
        }
        List<Vertex> weg = new List<Vertex>();
        Vertex knoten1 = stack.top();
        weg.insert(knoten1);
        weg.toFirst();
        stack.pop();
        while (!stack.isEmpty()){
            Vertex knoten2 = stack.top();
            stack.pop();
            Edge edge = bspGraph.getEdge(knoten1, knoten2);
            if (edge != null){
                weg.insert(knoten2);
                weg.toFirst();
                knoten1 = knoten2;
            }
        }
        return weg;
    }
      
  
   public String sucheAlleWegeToString(String start, String ziel){
     List<Vertex> weg = new List<Vertex>();
     List<List<Vertex>> alleWege = new List<List<Vertex>>();
     bspGraph.setAllVertexMarks(false);
     Vertex startKnoten = bspGraph.getVertex(start);
     Vertex zielKnoten = bspGraph.getVertex(ziel);
     sucheAlleWege(startKnoten, zielKnoten, weg, alleWege);
     String alleWegeString = "";
     alleWege.toFirst();
     while (alleWege.hasAccess()){
         List<Vertex> einWeg = alleWege.getContent();
         alleWegeString = alleWegeString + knotenListeToString(einWeg)+"\n";
         alleWege.next();
        }
      return alleWegeString;
   }
   
   

   
  public void  sucheAlleWege(Vertex knoten, Vertex ziel, List<Vertex> weg, List<List<Vertex>> alleWege){
      knoten.setMark(true);
      weg.append(knoten);
      if (knoten != ziel){ 
          List<Vertex> nachbarn = bspGraph.getNeighbours(knoten);
          nachbarn.toFirst();
          while (nachbarn.hasAccess()) {
              Vertex nachbar = nachbarn.getContent();
              if (!nachbar.isMarked()){
                  sucheAlleWege(nachbar, ziel, weg, alleWege);
                  //Schritt rckgngig machen
                  weg.toLast();
                  Vertex loeschKnoten = weg.getContent();
                  loeschKnoten.setMark(false);
                  weg.remove(); 
               }
              nachbarn.next();
          } 
      } else {
          List<Vertex> einWeg = new List<Vertex>();
          copy(weg, einWeg);
          alleWege.append(einWeg);
        }
  }

}

